-------------------------------------------------------
--! @file bcd7seg.vhd
--! @brief BCD to 7-segment encoder
--! @author Edson S. Gomi (gomi@usp.br)
--! @date 2020-04-01
-------------------------------------------------------

entity bcd7seg is
  port (
    EN : in  bit;
    D :  in  bit_vector (3 downto 0);
    S :  out bit_vector (6 downto 0)
    );
end entity bcd7seg;

architecture when_else of bcd7seg is
begin
  S <=
    "0000000" when (EN = '0') else
    "1111110" when (D = "0000") else
    "0110000" when (D = "0001") else
    "1101101" when (D = "0010") else
    "1111001" when (D = "0011") else
    "0110011" when (D = "0100") else
    "1011011" when (D = "0101") else
    "1011111" when (D = "0110") else
    "1110000" when (D = "0111") else
    "1111111" when (D = "1000") else
    "1111011" when (D = "1001") else
    "0000000";
end architecture when_else;


           
                    
