-------------------------------------------------------
--! @file dec3to8.vhd
--! @brief Decoder 3 to 8 with enable
--! @author Edson S. Gomi (gomi@usp.br)
--! @date 2019-04-09
-------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

entity dec3to8 is
  port (
    EN : in std_logic;
    I : in std_logic_vector (2 downto 0);
    Y : out std_logic_vector (7 downto 0)
    );
end entity dec3to8;

architecture with_select of dec3to8 is

  signal Z : std_logic_vector (7 downto 0);

begin
  
  Y <= "00000000" when EN = '0' else Z;

  with I select         
    Z <=
    "00000001" when "000",
    "00000010" when "001",    
    "00000100" when "010",    
    "00001000" when "011",
    "00010000" when "100",
    "00100000" when "101",
    "01000000" when "110",
    "10000000" when "111",
    "XXXXXXXX" when others;
  
end architecture with_select;


