-------------------------------------------------------
--! @file mux_2to1.vhd
--! @brief 2 to 1 multiplexer
--! @author Edson S. Gomi (gomi@usp.br)
--! @date 2020-04-01
-------------------------------------------------------

entity mux_2to1 is
  port (
    SEL : in  bit;
    I   : in  bit_vector (1 downto 0);
    Y   : out bit
    );
end entity mux_2to1;

architecture with_select of mux_2to1 is
begin
  with SEL select
    Y <=
    I(0) when '0',
    I(1) when '1',
    '0' when others;
end with_select;

    
